/* Josh Pieper, (c) 2000 */

/* This file is distributed under the GPL, see file COPYING for details */

#ifndef GNUT_HASH_H
#define GNUT_HASH_H

#include "gnut_lib.h"
#include "Gnut_List.h"

typedef struct _Gnut_Hash Gnut_Hash;

struct _Gnut_Hash {
	uchar (*hash_func)(void *);
	int (*compare_func)(void *, void *);
	Gnut_List *list[256];
};
	

int gnut_hash_foreach(Gnut_Hash *, int (*a)(void *, void *), void *);
Gnut_Hash * gnut_hash_new(uchar (*hash_func)(void *), 
	int (*compare_func)(void *, void *));
void gnut_hash_insert(Gnut_Hash *,void *);
void * gnut_hash_find(Gnut_Hash *,void *);
void * gnut_hash_find_raw(Gnut_Hash *,void *);
uint32 gnut_hash_remove(Gnut_Hash *,void *);
uint32 gnut_hash_free(Gnut_Hash *);



#endif
