/* Josh Pieper, (c) 2000 */

/* This file is distruted under the GPL, see file COPYING for details */

#ifndef GNUT_THREADS_H
#define GNUT_THREADS_H

#include <sys/types.h>
#ifndef WIN32
#include <netinet/in.h>
#include <sys/socket.h>
#endif
#include "share.h"
#include "gnut_lib.h"


typedef struct _incoming_arg incoming_arg;
typedef struct _push_arg push_arg;

struct _incoming_arg {
	int s;
	struct sockaddr_in sin;
};

struct _push_arg {
	share_item *si;
	uchar ip[4];
	uchar port[2];
};

int gnut_threads_num_incoming();
int gnut_threads_num_outgoing();
int gnut_threads_num_uploads();
int gnut_threads_count_downloads();
int gnut_threads_count_uploads();
int gnut_threads_num_downloads();

void * gnut_threads_outgoing(void *arg);
void * gnut_threads_incoming(void *arg);
void * gnut_threads_transfer(void *arg);
void * gnut_threads_push(void *arg);

#ifdef PTHREADS_DRAFT4
extern pthread_mutex_t gc_list_mutex, send_mutex, _g_debug_mutex,
		make_connection_mutex, transfer_mutex, host_mutex,
		monitor_mutex, push_mutex, query_mutex, route_mutex, 
                share_mutex, cache_mutex;
void gnut_mutexes_init();

#ifdef hpux
/*
 * HP-UX does some icky things at 10.20
 */
 
#ifdef sigaction
#undef sigaction
#define sigaction(a,b,c) cma_sigaction(a,b,c)
#endif

#ifdef select
#undef select
#define select(a,b,c,d,e) cma_select(a,(int *)b,(int *)c,(int *)d,e)
#endif

typedef union {
	pthread_t pthreadpart;
	long	longpart;
} HPUX_hack;

#endif hpux
#endif /* PTHREADS_DRAFT4 */

#endif
