/* Josh Pieper, (c) 2000 */

/* This file is distributed under the GPL, see file COPYING for details */

#ifndef GNUT_TRANSFER_H
#define GNUT_TRANSFER_H

#include <time.h>
#include "gnut_lib.h"

typedef struct _gnut_transfer gnut_transfer;

struct _gnut_transfer {
	int sock;
	
	uchar ip[4];
	uint16 port;
	
	int fsock;
	char *fname;
	
	// indicates whether an upload, or download, or push
	int type;
	
	int bytes;
	int total;
	
	int rate_bytes;
	time_t rate_start_time;

	int rate_limit;
	
	// states are the same as for connections
	int state;
	
	// for ui purposes...
	int index;

	pthread_t tid;
};

gnut_transfer * gnut_transfer_new();
int gnut_transfer_delete(gnut_transfer *gt);

int gnut_transfer_loop(gnut_transfer *gt);

int gnut_transfer_enumerate( int(*a)(gnut_transfer *));

int gnut_transfer_num();

#endif
