/* Josh Pieper, (c) 2000 */

/* This file is distributed under the GPL, see file COPYING for details */

#ifndef HOST_H
#define HOST_H

#include "gnut_lib.h"
#include "Gnut_List.h"
#include "Gnut_Hash.h"

typedef struct _host_entry host_entry;

struct _host_entry {
	uchar ip[4];
	uchar port[2];
	uint32	files;
	uint32	bytes;
};

int host_save(char *fname);
int host_restore(char *fname);


int host_add(host_entry *he);
int host_find(uchar ip[4], uchar port[2]);
int host_clear();
int host_remove(uchar ip[4], uchar port[2]);
int host_totals(uint *num, uint64 *files, uint64 *size);
int host_init();

int host_lock();
Gnut_Hash * host_retrieve();
int host_unlock();

#endif
